﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Plane.FormationCreator.Formation
{
    public partial class FlightTask
    {
        public async Task MutilLandTaskAsync()
        {
            int TaskCount = _flightTaskManager.Tasks.Count();
            if (TaskCount > 1)
            {
                var infos = SingleCopterInfos;
                // var infos = SingleCopterInfos.OrderByDescending(i => i.TargetAlt).ToList();
                var tasks = new Task[infos.Count];
                var tasksTmp = new Task[infos.Count];
                Task[] test = new Task[infos.Count];
                for (int i = 0; i < infos.Count; i++)
                {
                    var info = infos[i];
                    test[i] = LandTaskAsync(info);
                }
                await Task.WhenAll(test).ConfigureAwait(false);

            }

        }


        private async Task LandTaskAsync(FlightTaskSingleCopterInfo info)
        {
            DateTime dtNow = DateTime.Now;
            DateTime dtLastTime = DateTime.Now;
            TimeSpan ts = dtNow - dtLastTime;
            int waittime = (int)info.LandWaitTime * 1000;

            while (ts.TotalMilliseconds < waittime)
            {
                if (_flightTaskManager.IsPaused == true)
                {
                    await info.Copter.HoverAsync();
                    return;

                }
                await Task.Delay(100).ConfigureAwait(true);

                dtNow = DateTime.Now;
                ts = dtNow - dtLastTime;
            }
            await info.Copter.LandAsync();
            while ((info.Copter.Altitude>0.0f)) 
             {
                if (_flightTaskManager.IsPaused == true)
                {
                    await info.Copter.HoverAsync();
                    return;
                   
                }
                await Task.Delay(100).ConfigureAwait(true);

            }


        }
    }
}
