﻿using MahApps.Metro.Controls;
using Microsoft.Practices.ServiceLocation;
using Plane.FormationCreator.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Plane.FormationCreator.Views
{
    /// <summary>
    /// RtcmInfoView.xaml 的交互逻辑
    /// </summary>
    public partial class RtcmInfoView : MetroWindow
    {
        private static RtcmInfoView staticInstance = null;
        public static RtcmInfoView GetInstance()
        {
            if (staticInstance == null)
            {
                staticInstance = new RtcmInfoView();
            }
            return staticInstance;
        }


        RtcmInfoViewModel _rtcmInfoViewModel = ServiceLocator.Current.GetInstance<RtcmInfoViewModel>();
        public RtcmInfoView()
        {
            InitializeComponent();
            this.DataContext = _rtcmInfoViewModel;
            this.Closed += WindowOnClosed;
        }

        private void ComboBox_DropDownOpened(object sender, EventArgs e)
        {
            _rtcmInfoViewModel.RefreshPorts();

        }

        private void WindowOnClosed(object sender, System.EventArgs e)
        {
            staticInstance = null;
        }
    }
}
