﻿using HelixToolkit.Wpf;
using Microsoft.Practices.ServiceLocation;
using Plane.FormationCreator.Formation;
using Plane.FormationCreator.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Media3D;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Plane.FormationCreator.Views
{
    /// <summary>
    /// View3D.xaml 的交互逻辑
    /// </summary>
    public partial class View3D : UserControl
    {
        private FlightTaskManager _flightTaskManager = ServiceLocator.Current.GetInstance<FlightTaskManager>();
        private View3DViewModel _view3DManager = ServiceLocator.Current.GetInstance<View3DViewModel>();
        public View3D()
        {
            InitializeComponent();

            ResetCamera();

            _flightTaskManager = ServiceLocator.Current.GetInstance<FlightTaskManager>();
            _view3DManager = ServiceLocator.Current.GetInstance<View3DViewModel>();
            this.DataContext = _view3DManager;

        }

        private void ResetCamera()
        {
            //             view3d.CameraController.CameraPosition = new Point3D(0, 40, 1);
            //             view3d.CameraController.CameraUpDirection = new Vector3D(0, -1, 10);
            //             view3d.CameraController.CameraTarget = new Point3D(0, 1, 10);
            //             view3d.CameraController.CameraMode = CameraMode.FixedPosition;
            //             view3d.CameraController.CameraRotationMode = CameraRotationMode.Turntable;

            var camera = view3d.Camera as PerspectiveCamera;
            camera.Position = new Point3D(0, 0, 1);
            //用于180度
            camera.LookDirection = new Vector3D(-0.025, -0.911, 0.411);
            camera.UpDirection = new Vector3D(0.011, 0.411, 0.912);
            
            //用于0度
            //camera.LookDirection = new Vector3D(0, 1, 0);
            //camera.UpDirection = new Vector3D(0,0, 1);


            camera.FieldOfView = 120;
            _view3DManager.Clear3DCopters();
            //for test 用来确定上面的参数
            //view3d.ShowCameraInfo = true;
            //view3d.ShowFieldOfView = true;

        }

        private void ResetCamera_Click(object sender, RoutedEventArgs e)
        {
            ResetCamera();
        }
    }
}
